package lcds.examples.bookie.dao;

import javax.naming.InitialContext;
import javax.naming.NamingException;

public class DAOLookupHelper {

	private static DAOLookupHelper instance;
	private static String JNDIPrefix = "bookie/";
	private InitialContext context;
	
	private DAOLookupHelper() throws NamingException {
		context = new InitialContext();
	}
	
	public static DAOLookupHelper getInstance() throws NamingException {
		if (instance == null) {
			instance = new DAOLookupHelper();
		}
		
		return instance;
	}
	
	public void setJNDIPrefix(String prefix) {
		JNDIPrefix = prefix;
		if (prefix != "") JNDIPrefix += "/";
	}
	
	public BookDAO getBookDAO() throws NamingException {
		Object proxy = lookup("BookDAOBean/local");
		return (BookDAO)proxy;
	}

	public SubjectDAO getSubjectDAO() throws NamingException {
		return (SubjectDAO)lookup("SubjectDAOBean/local");
	}

	public PersonDAO getPersonDAO() throws NamingException {
		return (PersonDAO)lookup("PersonDAOBean/local");
	}

	public ReservationDAO getReservationDAO() throws NamingException {
		return (ReservationDAO)lookup("ReservationDAOBean/local");
	}

	private Object lookup(String name) throws NamingException {
		String lookupName = JNDIPrefix + name;
		return context.lookup(lookupName);
	}

}
