package lcds.examples.bookie.dao.beans;

import java.util.List;

import javax.ejb.Local;
import javax.ejb.Stateless;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import javax.persistence.Query;

import lcds.examples.bookie.dao.SubjectDAO;
import lcds.examples.bookie.entity.Subject;


@SuppressWarnings("unchecked")
@Stateless
@Local(value={SubjectDAO.class})
public class SubjectDAOBean implements SubjectDAO {

	@PersistenceContext
	private EntityManager entityManager;

	public void persist(Subject transientInstance) {
		try {
			entityManager.persist(transientInstance);
		} catch (RuntimeException re) {
			throw re;
		}
	}

	public void remove(Subject persistentInstance) {
		try {
			entityManager.remove(persistentInstance);
		} catch (RuntimeException re) {
			throw re;
		}
	}
	
	public void removeDetached(Subject detachedInstance) {
		remove(merge(detachedInstance));
	}
	
	public Subject merge(Subject detachedInstance) {
		try {
			Subject result = entityManager.merge(detachedInstance);
			return result;
		} catch (RuntimeException re) {
			throw re;
		}
	}

	public Subject findById(int id) {
		try {
			Subject instance = entityManager.find(Subject.class, id);
			return instance;
		} catch (RuntimeException re) {
			throw re;
		}
	}

	public List<Subject> getAll() {
		Query q = entityManager.createQuery(
			" from Subject s" +
			" order by s.name"
		);
		return q.getResultList();
	}

	public List<Subject> findByName(String name) {
		Query q = entityManager.createQuery(
			" from Subject s" +
			" where s.name like '%" + name + "%' " +
			" order by s.name"
		);
		return q.getResultList();
	}
	
}
