package lcds.examples.bookie.entity;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.OneToOne;
import javax.persistence.Table;

import org.apache.commons.lang.builder.EqualsBuilder;
import org.apache.commons.lang.builder.HashCodeBuilder;
import org.apache.commons.lang.builder.ToStringBuilder;

@SuppressWarnings("serial")
@Entity
@Table(name="books")
public class Book extends BaseEntity {

	private Subject subject;
	private String title;
	private String isbn;
	private Person author;
	
	public Book() {
	}

	@Column(name="title")
	public String getTitle() {
		return title;
	}
	
	public void setTitle(String title) {
		this.title = title;
	}
	
	@Column(name="isbn")
	public String getIsbn() {
		return isbn;
	}
	
	public void setIsbn(String isbn) {
		this.isbn = isbn;
	}

	@ManyToOne(fetch=FetchType.EAGER, cascade={})
	@JoinColumn(name="author_id")
	public Person getAuthor() {
		return author;
	}

	public void setAuthor(Person author) {
		this.author = author;
	}
	
	@OneToOne(fetch=FetchType.EAGER, cascade={})
	@JoinColumn(name="subject_id")
	public Subject getSubject() {
		return subject;
	}

	public void setSubject(Subject subject) {
		this.subject = subject;
	}
	
	public String toString() {
		return new ToStringBuilder(this)
		.appendSuper(super.toString())
		.append("Title", title)
		.append("ISBN", isbn)
		.append("Subject", subject)
		.append("Author", author)
		.toString();
	}

	public boolean equals(Object obj) {
		if (obj instanceof Book == false) return false;
		
		if (obj == this) return true;
		
		Book theOther = (Book)obj;
		
		return new EqualsBuilder()
		.appendSuper(super.equals(obj))
		.append(title, theOther.getTitle())
		.append(isbn, theOther.getIsbn())
		.append(subject, theOther.getSubject())
		.append(author, theOther.getAuthor())
		.isEquals();
	}
	
	public int hashCode() {
		return new HashCodeBuilder(31,65)
		.appendSuper(super.hashCode())
		.append(title)
		.append(isbn)
		.append(subject)
		.append(author)
		.toHashCode();
	}
	
}
