package lcds.examples.bookie.entity;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;

import org.apache.commons.lang.builder.EqualsBuilder;
import org.apache.commons.lang.builder.HashCodeBuilder;
import org.apache.commons.lang.builder.ToStringBuilder;

@SuppressWarnings({"serial", "unchecked"})
@Entity
@Table(name="people")
public class Person extends BaseEntity {

	private String firstName;
	private String lastName;
	private String cardNumber;
	private boolean author;
	
	@Column(name="first_name")
	public String getFirstName() {
		return firstName;
	}
	
	public void setFirstName(String firstName) {
		this.firstName = firstName;
	}
	
	@Column(name="last_name")
	public String getLastName() {
		return lastName;
	}
	
	public void setLastName(String lastName) {
		this.lastName = lastName;
	}
	
	@Column(name="card_number")
	public String getCardNumber() {
		return cardNumber;
	}

	public void setCardNumber(String cardNumber) {
		this.cardNumber = cardNumber;
	}

	@Column(name="author")
	public boolean isAuthor() {
		return author;
	}

	public void setAuthor(boolean author) {
		this.author = author;
	}

	public String toString() {
		return new ToStringBuilder(this)
		.appendSuper(super.toString())
		.append("First Name", firstName)
		.append("Last Name", lastName)
		.toString();
	}

	public boolean equals(Object obj) {
		if (obj instanceof Person == false) return false;
		
		if (obj == this) return true;
		
		Person theOther = (Person)obj;
		
		return new EqualsBuilder()
		.appendSuper(super.equals(obj))
		.append(firstName, theOther.getFirstName())
		.append(lastName, theOther.getLastName())
		.isEquals();
	}
	
	public int hashCode() {
		return new HashCodeBuilder(43,99)
		.appendSuper(super.hashCode())
		.append(firstName)
		.append(lastName)
		.toHashCode();
	}
}
