package lcds.examples.bookie.entity;

import java.util.Calendar;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.JoinColumn;
import javax.persistence.OneToOne;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;

import org.apache.commons.lang.builder.EqualsBuilder;
import org.apache.commons.lang.builder.HashCodeBuilder;
import org.apache.commons.lang.builder.ToStringBuilder;

@SuppressWarnings("serial")
@Entity
@Table(name="reservations")
public class Reservation extends BaseEntity {

	private Calendar reservedOn;
	private Calendar reservedTill;
	private Book book;
	private Person person;
	
	@OneToOne(fetch=FetchType.EAGER, cascade={})
	@JoinColumn(name="book_id")
	public Book getBook() {
		return book;
	}
	
	public void setBook(Book book) {
		this.book = book;
	}
	
	@OneToOne(fetch=FetchType.EAGER, cascade={})
	@JoinColumn(name="person_id")
	public Person getPerson() {
		return person;
	}
	
	public void setPerson(Person person) {
		this.person = person;
	}
	
	@Temporal(TemporalType.TIMESTAMP)
	@Column(name="reserved_on")
	public Calendar getReservedOn() {
		return reservedOn;
	}
	
	public void setReservedOn(Calendar reservedOn) {
		this.reservedOn = reservedOn;
	}
	
	@Temporal(TemporalType.TIMESTAMP)
	@Column(name="reserved_till")
	public Calendar getReservedTill() {
		return reservedTill;
	}
	
	public void setReservedTill(Calendar reservedTill) {
		this.reservedTill = reservedTill;
	}
	
	public String toString() {
		return new ToStringBuilder(this)
		.appendSuper(super.toString())
		.append("Reserved On", reservedOn)
		.append("Reserved Until", reservedTill)
		.append("Book", book)
		.append("Person", person)
		.toString();
	}

	public boolean equals(Object obj) {
		if (obj instanceof Reservation == false) return false;
		
		if (obj == this) return true;
		
		Reservation theOther = (Reservation)obj;
		
		return new EqualsBuilder()
		.appendSuper(super.equals(obj))
		.append(reservedOn, theOther.getReservedOn())
		.append(reservedTill, theOther.getReservedTill())
		.append(book, theOther.getBook())
		.append(person, theOther.getPerson())
		.isEquals();
	}
	
	public int hashCode() {
		return new HashCodeBuilder(45,67)
		.appendSuper(super.hashCode())
		.append(reservedOn)
		.append(reservedTill)
		.append(book)
		.append(person)
		.toHashCode();
	}

}
