package lcds.examples.bookie.entity;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;

import org.apache.commons.lang.builder.EqualsBuilder;
import org.apache.commons.lang.builder.HashCodeBuilder;
import org.apache.commons.lang.builder.ToStringBuilder;

@SuppressWarnings("serial")
@Entity
@Table(name="subjects")
public class Subject extends BaseEntity {

	private String name;

	@Column(name="name")
	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}
	
	public String toString() {
		return new ToStringBuilder(this)
		.appendSuper(super.toString())
		.append("Name", name)
		.toString();
	}

	public boolean equals(Object obj) {
		if (obj instanceof Subject == false) return false;
		
		if (obj == this) return true;
		
		Subject theOther = (Subject)obj;
		
		return new EqualsBuilder()
		.appendSuper(super.equals(obj))
		.append(name, theOther.getName())
		.isEquals();
	}
	
	public int hashCode() {
		return new HashCodeBuilder(31,65)
		.appendSuper(super.hashCode())
		.append(name)
		.toHashCode();
	}

}
