package lcds.examples.bookie.entity.listeners;

import java.util.GregorianCalendar;

import javax.persistence.PrePersist;
import javax.persistence.PreUpdate;

import lcds.examples.bookie.entity.BaseEntity;


public class CreateUpdateTimestampEventListener {
	
	@PrePersist
	public void setCreateDateTime(Object entity) throws IllegalArgumentException {
		try {
			BaseEntity stampable = (BaseEntity)entity;
			
			stampable.setCreatedOn(new GregorianCalendar());
		} catch (Exception e) {
			throw new IllegalArgumentException("Problem timestamping at creation. Entity '" + entity.getClass().getName() + "' may not extend BaseEntity");
		}
	}
	
	@PreUpdate
	public void setUpdateDateTime(Object entity) throws IllegalArgumentException {
		try {
			BaseEntity stampable = (BaseEntity)entity;
			
			stampable.setUpdatedOn(new GregorianCalendar());
		} catch (Exception e) {
			throw new IllegalArgumentException("Problem timestamping at update. Entity '" + entity.getClass().getName() + "' may not extend BaseEntity");
		}
	}
	
}
