package lcds.examples.bookie;

import java.io.InputStream;
import java.sql.Connection;
import java.sql.DriverManager;
import java.util.Properties;

public class ConnectionHelper {

	private String driverClassName;
	private String url;
	private String username;
	private String password;

	public ConnectionHelper() throws Exception {
		InputStream is = this.getClass().getResourceAsStream("/lcds/examples/bookie/database.properties");
		Properties p = new Properties();
		p.load(is);
		driverClassName	= p.getProperty("database.driverClassName");
		url				= p.getProperty("database.url");
		username		= p.getProperty("database.username");
		password		= p.getProperty("database.password");
		
		Class.forName(driverClassName);
	}
	
	public Connection getConnection() throws Exception {
		return DriverManager.getConnection(url, username, password);
	}
	
}
