package lcds.examples.bookie.business {

	import com.adobe.cairngorm.enterprise.business.EnterpriseServiceLocator;
	
	import lcds.examples.bookie.entity.Book;
	import lcds.examples.bookie.entity.Person;
	import lcds.examples.bookie.entity.Reservation;
	import lcds.examples.bookie.entity.Subject;
	
	import mx.collections.ArrayCollection;
	import mx.collections.ListCollectionView;
	import mx.data.DataService;
	import mx.rpc.AsyncToken;
	import mx.rpc.IResponder;
	import mx.rpc.remoting.RemoteObject;
	
	public class AdminDelegate {
		
		private static const CHECKED_OUT:Boolean		= true;
		private static const AWAITING_CHECK_OUT:Boolean	= !CHECKED_OUT;
		private static const LIMIT_TO_AUTHORS:Boolean	= true;
	
		private var subjectService:DataService;
		private var personService:DataService;
		private var bookService:DataService;
		private var reservationService:DataService;
	
		public function AdminDelegate() {		
			subjectService = EnterpriseServiceLocator.getInstance().getDataService("subjectDataService");
			personService = EnterpriseServiceLocator.getInstance().getDataService("personDataService");
			bookService = EnterpriseServiceLocator.getInstance().getDataService("bookDataService");
			reservationService = EnterpriseServiceLocator.getInstance().getDataService("reservationDataService");
		}
	
		public function getAllSubjects(collection:ListCollectionView):void {	
			subjectService.fill(collection);
		}
		
		public function deleteSubject(subject:Subject):void {
			subjectService.deleteItem(subject);
		}
		
		public function getAllAuthors(collection:ListCollectionView):void {	
			personService.fill(collection, LIMIT_TO_AUTHORS);
		}
		
 		public function getAllPeople(collection:ListCollectionView):void {	
			personService.fill(collection, !LIMIT_TO_AUTHORS);
		}
		
		public function deletePerson(person:Person):void {
			personService.deleteItem(person);
		}
		
		public function getAllBooks(collection:ListCollectionView):void {	
			bookService.fill(collection);
		}
		
		public function deleteBook(book:Book):void {
			bookService.deleteItem(book);
		}
		
		public function getAllReservationsAwaitingCheckOut(collection:ListCollectionView):void {	
			reservationService.fill(collection, AWAITING_CHECK_OUT);
		}
		
		public function getAllReservationsCheckedOut(collection:ListCollectionView):void {	
			reservationService.fill(collection, CHECKED_OUT);
		}
		
		public function deleteReservations(reservations:Array):void {
			for (var i:int; i<reservations.length; i++) {
				reservationService.deleteItem(reservations[i]);
			}
		}
		
	}
}
