﻿package lcds.examples.bookie.business {

	import com.adobe.cairngorm.enterprise.business.EnterpriseServiceLocator;
	
	import lcds.examples.bookie.entity.Person;
	import lcds.examples.bookie.entity.Reservation;
	import lcds.examples.bookie.entity.Subject;
	
	import mx.collections.ArrayCollection;
	import mx.collections.ListCollectionView;
	import mx.data.DataService;
	import mx.rpc.AsyncToken;
	import mx.rpc.IResponder;
	import mx.rpc.remoting.RemoteObject;
	import com.adobe.cairngorm.business.ServiceLocator;
	
	public class BookieDelegate {
	
		private static const LIMIT_TO_AUTHORS:Boolean = true;
		
		private var responder:IResponder;
		private var bookSearchService:RemoteObject;
		private var subjectService:DataService;
		private var personService:DataService;
		private var reservationService:DataService;
	
		public function BookieDelegate(responder:IResponder=null) {		
			bookSearchService = ServiceLocator.getInstance().getRemoteObject("bookSearchService");
			subjectService = EnterpriseServiceLocator.getInstance().getDataService("subjectDataService");
			personService = EnterpriseServiceLocator.getInstance().getDataService("personDataService");
			reservationService = EnterpriseServiceLocator.getInstance().getDataService("reservationDataService");
			this.responder = responder;
		}
	
		public function findPersonByCardNumber(cardNumber:String):void {	
			var call:AsyncToken = bookSearchService.findPersonByCardNumber(cardNumber);
			call.addResponder(responder);
		}
		
		public function findBooksByAuthor(author:Person):void {	
			var call:AsyncToken = bookSearchService.findBooksByAuthor(author);
			call.addResponder(responder);
		}
		
		public function findBooksByTitle(title:String):void {	
			var call:AsyncToken = bookSearchService.findBooksByTitle(title);
			call.addResponder(responder);
		}
		
		public function findBooksBySubject(subject:Subject):void {	
			var call:AsyncToken = bookSearchService.findBooksBySubject(subject);
			call.addResponder(responder);
		}
		
		public function getAllSubjects(collection:ListCollectionView):void {	
			subjectService.fill(collection);
		}
		
		public function findSubjectsByName(collection:ListCollectionView, name:String):void {
			subjectService.fill(collection, name);
		}
		
		public function getAllAuthors(collection:ListCollectionView):void {	
			personService.fill(collection, LIMIT_TO_AUTHORS);
		}
		
		public function findAuthorsByName(collection:ListCollectionView, name:String):void {
			personService.fill(collection, name, !LIMIT_TO_AUTHORS);
		}
		
		public function reserveBooks(reservations:ArrayCollection):void {
			for each (var reservation:Reservation in reservations) {
				reservationService.createItem(reservation);
			}
		}
		
	}
}
