package lcds.examples.bookie.business {
	
	import com.adobe.cairngorm.business.ServiceLocator;
	import com.adobe.cairngorm.control.CairngormEvent;
	import com.adobe.cairngorm.control.CairngormEventDispatcher;
	import com.adobe.cairngorm.view.ViewLocator;
	
	import lcds.examples.bookie.control.AdminController;
	import lcds.examples.bookie.entity.Reservation;
	
	import mx.messaging.Consumer;
	import mx.messaging.events.MessageEvent;
	import lcds.examples.bookie.event.admin.ReservationRecievedEvent;
	import lcds.examples.bookie.view.admin.NewReservationNotification;
	
	
	public class NotificationManager {
		
		private static var instance:NotificationManager;
		
		private var _reservationNotificationView:NewReservationNotification;
		public function set reservationNotificationView(view:NewReservationNotification):void {
			_reservationNotificationView = view;
		}
		
		private var _consumer:Consumer;
		public function set reservationConsumer(consumer:Consumer):void {
			if (!consumer.subscribed) consumer.subscribe();
			consumer.addEventListener(MessageEvent.MESSAGE, onNewReservation);
			_consumer = consumer;
		}
		
		public static function getInstance():NotificationManager {
			if (instance == null) instance = new NotificationManager(new Instantiator());
			return instance;
		}
  
		public function NotificationManager(instantiator:Instantiator) {
			if (instantiator == null) throw new Error("NotificationManager can only be accessed through getInstance()");
		}
		
		public function onNewReservation(me:MessageEvent):void {
			var reservation:Reservation = Reservation(me.message.body);
			new ReservationRecievedEvent(reservation).dispatch();
			notifyOfReservation(reservation);
		}
		
		public function notifyOfReservation(reservation:Reservation):void {
			_reservationNotificationView.show(reservation);
		}

	}
}
class Instantiator {}