package lcds.examples.bookie.command {
	
	import com.adobe.cairngorm.commands.ICommand;
	import com.adobe.cairngorm.control.CairngormEvent;
	import lcds.examples.bookie.event.BooksChosenEvent;
	import lcds.examples.bookie.model.BookieModel;
	import lcds.examples.bookie.entity.Book;

	public class BooksChosenCommand implements ICommand {
		
		private var model:BookieModel = BookieModel.getInstance();
		
		public function execute(event:CairngormEvent):void {
			var evt:BooksChosenEvent = event as BooksChosenEvent;
			var books:Array = evt.books;
			for each (var book:Book in books) {
				if (!model.booksToReserve.contains(book)) {
					model.booksToReserve.addItem(book);
				}
			}
			
			model.currentState = BookieModel.BOOKS_CHOSEN;
		}
	}
}