﻿package lcds.examples.bookie.command {
	
	import com.adobe.cairngorm.commands.ICommand;
	import com.adobe.cairngorm.control.CairngormEvent;
	
	import lcds.examples.bookie.business.BookieDelegate;
	import lcds.examples.bookie.entity.Person;
	import lcds.examples.bookie.entity.Subject;
	import lcds.examples.bookie.event.SearchEvent;
	import lcds.examples.bookie.model.BookieModel;
	
	import mx.controls.Alert;
	import mx.rpc.IResponder;
	import mx.rpc.events.FaultEvent;
	import lcds.examples.bookie.event.FindBooksEvent;
	
	public class FindBooksCommand implements ICommand, IResponder {
	
		public function execute(event:CairngormEvent):void {
			var evt:FindBooksEvent = event as FindBooksEvent;
			var searchData:SearchEvent = evt.searchEvent;
			var delegate:BookieDelegate = new BookieDelegate(this);
			
			switch(searchData.searchType) {
				
				case SearchEvent.AUTHOR_SEARCH_TYPE :
					delegate.findBooksByAuthor(Person(searchData.searchData));
				break;
				
				case SearchEvent.TITLE_SEARCH_TYPE :
					delegate.findBooksByTitle(String(searchData.searchData));
				break;
				
				case SearchEvent.SUBJECT_SEARCH_TYPE :
					delegate.findBooksBySubject(Subject(searchData.searchData));
				break;
				
			}			
			
		}
	
		public function result(event:Object):void {
			BookieModel.getInstance().books = event.result;
		}
	
		public function fault(event:Object):void {
			mx.controls.Alert.show("Books could not be retrieved", "Error retrieving Books");
		}
	}

}
