package lcds.examples.bookie.command {
	
	import com.adobe.cairngorm.commands.ICommand;
	import com.adobe.cairngorm.control.CairngormEvent;
	import com.adobe.cairngorm.control.CairngormEventDispatcher;
	
	import lcds.examples.bookie.business.BookieDelegate;
	import lcds.examples.bookie.control.BookieController;
	import lcds.examples.bookie.entity.Book;
	import lcds.examples.bookie.entity.Reservation;
	import lcds.examples.bookie.model.BookieModel;
	
	import mx.collections.ArrayCollection;
	import mx.controls.Alert;
	import mx.rpc.IResponder;
	import mx.events.CloseEvent;
	import lcds.examples.bookie.event.ReserveBooksEvent;
	import lcds.examples.bookie.event.SignOutEvent;
	
	public class ReserveBooksCommand implements ICommand, IResponder {
	
		private var model:BookieModel = BookieModel.getInstance();
	
		public function execute(event:CairngormEvent):void {
			var evt:ReserveBooksEvent = event as ReserveBooksEvent;
			var books:Array = evt.books;
			var reservations:ArrayCollection = new ArrayCollection();
			
			var reservation:Reservation;
			for each (var book:Book in books) {
				reservation = new Reservation();
				reservation.book			= book;
				reservation.person			= model.user;
				//reservation.reservedOn	= new Date();
				//reservation.reservedTill	= model.getReservedTillDate(reservation.reservedOn);
				reservations.addItem(reservation);
			}
			
			var delegate:BookieDelegate = new BookieDelegate(this);
			delegate.reserveBooks(reservations);
			model.booksToReserve = new ArrayCollection();
			Alert.show("Your Books have been reserved. Please pick them up at the kiosk", "Books Reserved");
		}
	
		public function result(event:Object):void {
		}
		
		public function fault(event:Object):void {
			Alert.show("Books could not be reserved", "Error reserving Books");
		}
	}

}
