package lcds.examples.bookie.command {
	
	import com.adobe.cairngorm.commands.ICommand;
	import com.adobe.cairngorm.control.CairngormEvent;
	import com.adobe.cairngorm.view.ViewLocator;
	
	import lcds.examples.bookie.business.BookieDelegate;
	import lcds.examples.bookie.entity.Person;
	import lcds.examples.bookie.model.BookieModel;
	
	import mx.controls.Alert;
	import mx.rpc.IResponder;
	import lcds.examples.bookie.event.SignInEvent;
	
	public class SignInCommand implements ICommand, IResponder {
		
		private var model:BookieModel = BookieModel.getInstance();
		
		public function execute(event:CairngormEvent):void {
			var evt:SignInEvent = event as SignInEvent;
			var delegate:BookieDelegate = new BookieDelegate(this);
			delegate.findPersonByCardNumber(evt.cardNumber);
		}
		
		public function result(result:Object):void {
			if (result.result != null) {
				var p:Person = Person(result.result);
				model.user = p;
				model.loginFailedMessage = "";
				
				model.currentState = BookieModel.SIGNED_IN;
			} else {
				model.loginFailedMessage = "That card number was not found";
			}
			
		}
		
		public function fault(fault:Object):void {
			Alert.show("Unable to sign in", "Error while signing in");
		}
		
	}
}