﻿package lcds.examples.bookie.model {

	import com.adobe.cairngorm.model.ModelLocator;
	import mx.collections.ArrayCollection;
	import lcds.examples.bookie.entity.Person;
	import com.adobe.cairngorm.CairngormMessageCodes;

	[Bindable]
	public class BookieModel implements ModelLocator {
	
		private static var instance:BookieModel;
		
		//States
		public static const SIGNED_OUT:String	= 'SIGNED_OUT';
		public static const SIGNED_IN:String	= 'SIGNED_IN';
		public static const BOOKS_CHOSEN:String	= 'BOOKS_CHOSEN';
		
		public var currentState:String = SIGNED_OUT;
		
		public var user:Person;
		public var books:ArrayCollection = new ArrayCollection();
		public var authors:ArrayCollection = new ArrayCollection();
		public var subjects:ArrayCollection = new ArrayCollection();
		public var booksToReserve:ArrayCollection = new ArrayCollection();
		public var loginFailedMessage:String = "";
		
				
		
		public static function getInstance():BookieModel {
			if (instance == null) instance = new BookieModel(new ModelInitializer());
			return instance;
		}
  
		public function BookieModel(initializer:ModelInitializer) {
			if (initializer == null) throw new Error(CairngormMessageCodes.SINGLETON_EXCEPTION, 'BookieModel');
		}
		
		public function initialize():void {
			books = new ArrayCollection();
			authors = new ArrayCollection();
			subjects = new ArrayCollection();
			booksToReserve = new ArrayCollection();
			user = null;
			loginFailedMessage = "";
		}
		
		public function getReservedTillDate(reservedOn:Date):Date {
			var millisecondsPerWeek:int = 1000 * 60 * 60 * 24 * 7;
			// reserve books for 2 weeks
			var reservedTill:Date = new Date(reservedOn.getTime() + (2*millisecondsPerWeek));
			return reservedTill;
		}

	}
}
class ModelInitializer {}