package test {
	
	import flexunit.framework.TestCase;
	import flexunit.framework.TestSuite;
	import lcds.examples.bookie.model.BookieModel;
	import lcds.examples.bookie.model.AdminModel;
	import lcds.examples.bookie.event.SignOutEvent;

	public class BookieTests extends TestCase {
		
		private var model:BookieModel = BookieModel.getInstance();
		
		public function BookieTests(testMethod:String) {
			super(testMethod);
		}
		
		public static function suite():TestSuite {
			var testSuite:TestSuite = new TestSuite();
			
			testSuite.addTest(new BookieTests("testModelsAreSingletons"));
			testSuite.addTest(new BookieTests("testSignOutCommand"));
			
			return testSuite;
		}
		
		public function testModelsAreSingletons():void {
			var caughtBookieModelInstantiationError:Boolean;
			var caughtAdminModelInstantiationError:Boolean;
			var model:BookieModel;
			var adminModel:AdminModel;
			
			try {
				model = new BookieModel(null);
			} catch (e:Error) {
				caughtBookieModelInstantiationError = true;
			}
			
			try {
				adminModel = new AdminModel(null);
			} catch (e:Error) {
				caughtAdminModelInstantiationError = true;
			}
			
			assertTrue("Expected error instantiating singleton BookieModel", caughtBookieModelInstantiationError);
			assertTrue("Expected error instantiating singleton AdminModel", caughtAdminModelInstantiationError);
			assertUndefined(model)
			assertUndefined(adminModel);

			
			model = BookieModel.getInstance();
			adminModel = AdminModel.getInstance();
			
			assertNotUndefined(model)
			assertNotUndefined(adminModel)

		}
		
		public function testSignOutCommand():void {
			assertEquals("Model should initialize state to SIGNED_OUT", model.currentState, BookieModel.SIGNED_OUT)
			model.currentState = BookieModel.SIGNED_IN; // set state as if we were signed in
			new SignOutEvent().dispatch();
			assertEquals("Model should be SIGNED_OUT after sign out event.", model.currentState, BookieModel.SIGNED_OUT)
		}
		
	}
}