package lcds.examples.bookie.service;

import java.util.Collection;

import lcds.examples.bookie.dao.BookDAO;
import lcds.examples.bookie.dao.DAOLookupHelper;
import lcds.examples.bookie.dao.PersonDAO;
import lcds.examples.bookie.dao.ReservationDAO;
import lcds.examples.bookie.dao.SubjectDAO;
import lcds.examples.bookie.entity.Book;
import lcds.examples.bookie.entity.Person;
import lcds.examples.bookie.entity.Reservation;
import lcds.examples.bookie.entity.Subject;


public class BookSearchService {
		
	public Collection<Book> findBooksByAuthor(Person author) throws Exception {
		BookDAO dao = getBookDAO();
		return dao.findByAuthor(author);
	}
	
	public Collection<Book> findBooksBySubject(Subject subject) throws Exception {
		BookDAO dao = getBookDAO();
		return dao.findBySubject(subject);
	}
	
	public Collection<Book> findBooksByTitle(String title) throws Exception {
		BookDAO dao = getBookDAO();
		return dao.findByName(title);
	}
	
	public Collection<Subject> findSubjectsByName(String name) throws Exception {
		SubjectDAO dao = DAOLookupHelper.getInstance().getSubjectDAO();
		return dao.findByName(name);
	}
	
	public Collection<Person> findAuthorByName(String name) throws Exception {
		PersonDAO dao = DAOLookupHelper.getInstance().getPersonDAO();
		return dao.findByName(name, true);
	}
	
	public Person findPersonByCardNumber(String cardNumber) throws Exception {
		PersonDAO dao = DAOLookupHelper.getInstance().getPersonDAO();
		return dao.findByCardNumber(cardNumber);
	}
	
	public void reserveBooks(Collection<Reservation> reservations) throws Exception {
		ReservationDAO dao = DAOLookupHelper.getInstance().getReservationDAO();
		for (Reservation reservation : reservations) {
			dao.merge(reservation);
		}
	}
	
	private BookDAO getBookDAO() throws Exception {
		return DAOLookupHelper.getInstance().getBookDAO();
	}
	
}
